Index: sansmodels/src/c_models/flexcyl_ellipX.cpp
===================================================================
--- sansmodels/src/c_models/flexcyl_ellipX.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/flexcyl_ellipX.cpp	(revision 82c11d354f0cffa7741bd2e74e0641e042eeb034)
@@ -21,28 +21,38 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "flexcyl_ellipX.h"
 
 extern "C" {
-	#include "libCylinder.h"
-	#include "libStructureFactor.h"
-	#include "flexcyl_ellipX.h"
-}
+#include "libCylinder.h"
+#include "libStructureFactor.h"
+}
+
+typedef struct {
+  double scale;
+  double length;
+  double kuhn_length;
+  double radius;
+  double axis_ratio;
+  double sldCyl;
+  double sldSolv;
+  double background;
+} FlexCylEXParameters;
 
 FlexCylEllipXModel :: FlexCylEllipXModel() {
-	scale      = Parameter(1.0);
-	length     = Parameter(1000.0, true);
-	length.set_min(0.0);
-	kuhn_length = Parameter(100.0, true);
-	kuhn_length.set_min(0.0);
-	radius  = Parameter(20.0, true);
-	radius.set_min(0.0);
-	axis_ratio = Parameter(1.5);
-	axis_ratio.set_min(0.0);
-	sldCyl   = Parameter(1.0e-6);
-	sldSolv   = Parameter(6.3e-6);
-	background = Parameter(0.0001);
+  scale      = Parameter(1.0);
+  length     = Parameter(1000.0, true);
+  length.set_min(0.0);
+  kuhn_length = Parameter(100.0, true);
+  kuhn_length.set_min(0.0);
+  radius  = Parameter(20.0, true);
+  radius.set_min(0.0);
+  axis_ratio = Parameter(1.5);
+  axis_ratio.set_min(0.0);
+  sldCyl   = Parameter(1.0e-6);
+  sldSolv   = Parameter(6.3e-6);
+  background = Parameter(0.0001);
 }
 
@@ -54,72 +64,72 @@
  */
 double FlexCylEllipXModel :: operator()(double q) {
-	double dp[8];
-
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = scale();
-	dp[1] = length();
-	dp[2] = kuhn_length();
-	dp[3] = radius();
-	dp[4] = axis_ratio();
-	dp[5] = sldCyl();
-	dp[6] = sldSolv();
-	dp[7] = 0.0;
-
-	// Get the dispersion points for the length
-	vector<WeightPoint> weights_len;
-	length.get_weights(weights_len);
-
-	// Get the dispersion points for the kuhn_length
-	vector<WeightPoint> weights_kuhn;
-	kuhn_length.get_weights(weights_kuhn);
-
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	radius.get_weights(weights_rad);
-
-	// Get the dispersion points for the axis_ratio
-	vector<WeightPoint> weights_ratio;
-	axis_ratio.get_weights(weights_ratio);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-	double vol = 0.0;
-
-	// Loop over length weight points
-	for(int i=0; i< (int)weights_len.size(); i++) {
-		dp[1] = weights_len[i].value;
-
-		// Loop over kuhn_length weight points
-		for(int j=0; j< (int)weights_kuhn.size(); j++) {
-			dp[2] = weights_kuhn[j].value;
-
-			// Loop over radius weight points
-			for(int k=0; k< (int)weights_rad.size(); k++) {
-				dp[3] = weights_rad[k].value;
-				// Loop over axis_ratio weight points
-				for(int l=0; l< (int)weights_ratio.size(); l++) {
-					dp[4] = weights_ratio[l].value;
-
-					//Un-normalize by volume
-					sum += weights_len[i].weight * weights_kuhn[j].weight*weights_rad[k].weight
-						* weights_ratio[l].weight * FlexCyl_Ellip(dp, q)
-						* (pow(weights_rad[k].value,2.0) * weights_ratio[l].value * weights_len[i].value);
-					//Find weighted volume
-					vol += weights_rad[k].weight * weights_kuhn[j].weight
-						* weights_len[i].weight * weights_ratio[l].weight
-						*pow(weights_rad[k].value,2.0)* weights_ratio[l].weight*weights_len[i].value;
-					norm += weights_len[i].weight * weights_kuhn[j].weight
-						*weights_rad[k].weight* weights_ratio[l].weight;
-				}
-			}
-		}
-	}
-	if (vol != 0.0 && norm != 0.0) {
-		//Re-normalize by avg volume
-		sum = sum/(vol/norm);}
-
-	return sum/norm + background();
+  double dp[8];
+
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = scale();
+  dp[1] = length();
+  dp[2] = kuhn_length();
+  dp[3] = radius();
+  dp[4] = axis_ratio();
+  dp[5] = sldCyl();
+  dp[6] = sldSolv();
+  dp[7] = 0.0;
+
+  // Get the dispersion points for the length
+  vector<WeightPoint> weights_len;
+  length.get_weights(weights_len);
+
+  // Get the dispersion points for the kuhn_length
+  vector<WeightPoint> weights_kuhn;
+  kuhn_length.get_weights(weights_kuhn);
+
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_rad;
+  radius.get_weights(weights_rad);
+
+  // Get the dispersion points for the axis_ratio
+  vector<WeightPoint> weights_ratio;
+  axis_ratio.get_weights(weights_ratio);
+
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+  double vol = 0.0;
+
+  // Loop over length weight points
+  for(int i=0; i< (int)weights_len.size(); i++) {
+    dp[1] = weights_len[i].value;
+
+    // Loop over kuhn_length weight points
+    for(int j=0; j< (int)weights_kuhn.size(); j++) {
+      dp[2] = weights_kuhn[j].value;
+
+      // Loop over radius weight points
+      for(int k=0; k< (int)weights_rad.size(); k++) {
+        dp[3] = weights_rad[k].value;
+        // Loop over axis_ratio weight points
+        for(int l=0; l< (int)weights_ratio.size(); l++) {
+          dp[4] = weights_ratio[l].value;
+
+          //Un-normalize by volume
+          sum += weights_len[i].weight * weights_kuhn[j].weight*weights_rad[k].weight
+              * weights_ratio[l].weight * FlexCyl_Ellip(dp, q)
+          * (pow(weights_rad[k].value,2.0) * weights_ratio[l].value * weights_len[i].value);
+          //Find weighted volume
+          vol += weights_rad[k].weight * weights_kuhn[j].weight
+              * weights_len[i].weight * weights_ratio[l].weight
+              *pow(weights_rad[k].value,2.0)* weights_ratio[l].weight*weights_len[i].value;
+          norm += weights_len[i].weight * weights_kuhn[j].weight
+              *weights_rad[k].weight* weights_ratio[l].weight;
+        }
+      }
+    }
+  }
+  if (vol != 0.0 && norm != 0.0) {
+    //Re-normalize by avg volume
+    sum = sum/(vol/norm);}
+
+  return sum/norm + background();
 }
 
@@ -131,6 +141,6 @@
  */
 double FlexCylEllipXModel :: operator()(double qx, double qy) {
-	double q = sqrt(qx*qx + qy*qy);
-	return (*this).operator()(q);
+  double q = sqrt(qx*qx + qy*qy);
+  return (*this).operator()(q);
 }
 
@@ -143,7 +153,7 @@
  */
 double FlexCylEllipXModel :: evaluate_rphi(double q, double phi) {
-	//double qx = q*cos(phi);
-	//double qy = q*sin(phi);
-	return (*this).operator()(q);
+  //double qx = q*cos(phi);
+  //double qy = q*sin(phi);
+  return (*this).operator()(q);
 }
 /**
@@ -152,52 +162,52 @@
  */
 double FlexCylEllipXModel :: calculate_ER() {
-	FlexCylEXParameters dp;
-
-	dp.radius  = radius();
-	dp.length     = length();
-	dp.axis_ratio  = axis_ratio();
-
-	double rad_out = 0.0;
-	double suf_rad = sqrt(dp.radius*dp.radius*dp.axis_ratio );
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-
-	// Get the dispersion points for the total length
-	vector<WeightPoint> weights_length;
-	length.get_weights(weights_length);
-
-	// Get the dispersion points for minor radius
-	vector<WeightPoint> weights_radius ;
-	radius.get_weights(weights_radius);
-
-	// Get the dispersion points for axis ratio = major_radius/minor_radius
-	vector<WeightPoint> weights_ratio ;
-	axis_ratio.get_weights(weights_ratio);
-
-	// Loop over major shell weight points
-	for(int i=0; i< (int)weights_length.size(); i++) {
-		dp.length = weights_length[i].value;
-		for(int k=0; k< (int)weights_radius.size(); k++) {
-			dp.radius = weights_radius[k].value;
-			// Loop over axis_ratio weight points
-			for(int l=0; l< (int)weights_ratio.size(); l++) {
-				dp.axis_ratio = weights_ratio[l].value;
-				suf_rad = sqrt(dp.radius  * dp.radius  * dp.axis_ratio);
-				//Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
-				sum +=weights_length[i].weight * weights_radius[k].weight
-						* weights_ratio[l].weight *DiamCyl(dp.length,suf_rad)/2.0;
-				norm += weights_length[i].weight* weights_radius[k].weight* weights_ratio[l].weight;
-			}
-		}
-	}
-	if (norm != 0){
-		//return the averaged value
-		rad_out =  sum/norm;}
-	else{
-		//return normal value
-		//Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
-		rad_out = DiamCyl(dp.length,suf_rad)/2.0;}
-
-	return rad_out;
-}
+  FlexCylEXParameters dp;
+
+  dp.radius  = radius();
+  dp.length     = length();
+  dp.axis_ratio  = axis_ratio();
+
+  double rad_out = 0.0;
+  double suf_rad = sqrt(dp.radius*dp.radius*dp.axis_ratio );
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+
+  // Get the dispersion points for the total length
+  vector<WeightPoint> weights_length;
+  length.get_weights(weights_length);
+
+  // Get the dispersion points for minor radius
+  vector<WeightPoint> weights_radius ;
+  radius.get_weights(weights_radius);
+
+  // Get the dispersion points for axis ratio = major_radius/minor_radius
+  vector<WeightPoint> weights_ratio ;
+  axis_ratio.get_weights(weights_ratio);
+
+  // Loop over major shell weight points
+  for(int i=0; i< (int)weights_length.size(); i++) {
+    dp.length = weights_length[i].value;
+    for(int k=0; k< (int)weights_radius.size(); k++) {
+      dp.radius = weights_radius[k].value;
+      // Loop over axis_ratio weight points
+      for(int l=0; l< (int)weights_ratio.size(); l++) {
+        dp.axis_ratio = weights_ratio[l].value;
+        suf_rad = sqrt(dp.radius  * dp.radius  * dp.axis_ratio);
+        //Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
+        sum +=weights_length[i].weight * weights_radius[k].weight
+            * weights_ratio[l].weight *DiamCyl(dp.length,suf_rad)/2.0;
+        norm += weights_length[i].weight* weights_radius[k].weight* weights_ratio[l].weight;
+      }
+    }
+  }
+  if (norm != 0){
+    //return the averaged value
+    rad_out =  sum/norm;}
+  else{
+    //return normal value
+    //Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
+    rad_out = DiamCyl(dp.length,suf_rad)/2.0;}
+
+  return rad_out;
+}
Index: sansmodels/src/c_models/flexiblecylinder.cpp
===================================================================
--- sansmodels/src/c_models/flexiblecylinder.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/flexiblecylinder.cpp	(revision 82c11d354f0cffa7741bd2e74e0641e042eeb034)
@@ -18,19 +18,27 @@
  *   sansmodels/src/libigor
  *
- *	TODO: refactor so that we pull in the old sansmodels.c_extensions
  *	TODO: add 2d
  */
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "flexible_cylinder.h"
 
 extern "C" {
 	#include "libCylinder.h"
 	#include "libStructureFactor.h"
-	#include "flexible_cylinder.h"
 }
+
+typedef struct {
+  double scale;
+  double length;
+  double kuhn_length;
+  double radius;
+  double sldCyl;
+  double sldSolv;
+  double background;
+} FlexibleCylinderParameters;
 
 FlexibleCylinderModel :: FlexibleCylinderModel() {
Index: sansmodels/src/c_models/fractal.cpp
===================================================================
--- sansmodels/src/c_models/fractal.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/fractal.cpp	(revision 82c11d354f0cffa7741bd2e74e0641e042eeb034)
@@ -21,23 +21,22 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "fractal.h"
 
 extern "C" {
-	#include "libTwoPhase.h"
-	#include "fractal.h"
+#include "libTwoPhase.h"
 }
 
 FractalModel :: FractalModel() {
-	scale      = Parameter(1.0);
-    radius = Parameter(5.0, true);
-    radius.set_min(0.0);
-    fractal_dim = Parameter(2.0);
-    cor_length = Parameter(100.0);
-    sldBlock = Parameter(2.0e-6);
-    sldSolv= Parameter(6.35e-6);
-	background = Parameter(0.0);
+  scale      = Parameter(1.0);
+  radius = Parameter(5.0, true);
+  radius.set_min(0.0);
+  fractal_dim = Parameter(2.0);
+  cor_length = Parameter(100.0);
+  sldBlock = Parameter(2.0e-6);
+  sldSolv= Parameter(6.35e-6);
+  background = Parameter(0.0);
 }
 
@@ -49,43 +48,43 @@
  */
 double FractalModel :: operator()(double q) {
-	double dp[7];
+  double dp[7];
 
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = scale();
-	dp[1] = radius();
-	dp[2] = fractal_dim();
-	dp[3] = cor_length();
-	dp[4] = sldBlock();
-	dp[5] = sldSolv();
-	dp[6] = 0.0;
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = scale();
+  dp[1] = radius();
+  dp[2] = fractal_dim();
+  dp[3] = cor_length();
+  dp[4] = sldBlock();
+  dp[5] = sldSolv();
+  dp[6] = 0.0;
 
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	radius.get_weights(weights_rad);
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_rad;
+  radius.get_weights(weights_rad);
 
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-	double vol = 0.0;
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+  double vol = 0.0;
 
-	// Loop over radius weight points
-	for(size_t i=0; i<weights_rad.size(); i++) {
-		dp[1] = weights_rad[i].value;
+  // Loop over radius weight points
+  for(size_t i=0; i<weights_rad.size(); i++) {
+    dp[1] = weights_rad[i].value;
 
-		//Un-normalize Fractal by volume
-		sum += weights_rad[i].weight
-			* Fractal(dp, fabs(q)) * pow(weights_rad[i].value,3);
-		//Find average volume
-		vol += weights_rad[i].weight
-			* pow(weights_rad[i].value,3);
+    //Un-normalize Fractal by volume
+    sum += weights_rad[i].weight
+        * Fractal(dp, fabs(q)) * pow(weights_rad[i].value,3);
+    //Find average volume
+    vol += weights_rad[i].weight
+        * pow(weights_rad[i].value,3);
 
-		norm += weights_rad[i].weight;
-	}
+    norm += weights_rad[i].weight;
+  }
 
-	if (vol != 0.0 && norm != 0.0) {
-		//Re-normalize by avg volume
-		sum = sum/(vol/norm);}
-	return sum/norm + background();
+  if (vol != 0.0 && norm != 0.0) {
+    //Re-normalize by avg volume
+    sum = sum/(vol/norm);}
+  return sum/norm + background();
 }
 
@@ -97,6 +96,6 @@
  */
 double FractalModel :: operator()(double qx, double qy) {
-	double q = sqrt(qx*qx + qy*qy);
-	return (*this).operator()(q);
+  double q = sqrt(qx*qx + qy*qy);
+  return (*this).operator()(q);
 }
 
@@ -109,5 +108,5 @@
  */
 double FractalModel :: evaluate_rphi(double q, double phi) {
-	return (*this).operator()(q);
+  return (*this).operator()(q);
 }
 
@@ -117,5 +116,5 @@
  */
 double FractalModel :: calculate_ER() {
-	//NOT implemented yet!!! 'cause None shape Model
-	return 0.0;
+  //NOT implemented yet!!! 'cause None shape Model
+  return 0.0;
 }
